{*************************************************************}
{            Deactivate/Minimize & Close Application          }
{ Version:   1.0                                              }
{ Author:    Milic Tomislav, B.Sc., Belgrade, Yugoslavia      }
{            Milic Tomislav, dipl.ing, Beograd, Jugoslavija   }
{ E-Mail:    milict@yahoo.com                                 }
{ Home Page:                                                  }
{ Created:        7 Oct 1999.                                 }
{ Last Modified:  7 Oct 1999.                                 }
{ Legal:     Copyright (c) 1999 by Milic Tomislav             }
{*************************************************************}
{ NOTE:                                                       }
{ This component is email-ware, so, email me your comments,   }
{ suggestions and bugs. If you like or use this component,    }
{ I would appreciate your opinion.                            }
{*************************************************************}
{ TDeactMinClose :                                            }
{ This component will minimize and close your application     }
{ if it is idle for some time or if you switched to another   }
{ application and had forgot this one.                        }
{*************************************************************}
{ PROPERTIES:                                                 }

{-DeactivateToMinimize : Number of minutes to wait after you  }
{ switched to another application to minimize your application}
{ default 0 try 3 (min)                                       }

{-IdleToMinimize : Number of minutes to wait to minimize your }
{ application after you left computer (app is idle)           }
{ default 0 try 5-15 (min)                                    }

{-MinimizeToClose : Number of minutes after you or this       }
{ component had minimized application when it should be closed}
{ default 0 try 5 (min)                                       }

{ Default (0) means don't use this option at all.             }
{*************************************************************}
{ EVENTS:                                                     }

{  - OnMinimize (optional)                                    }
{ If you don't define your event handler, application will be }
{ minimized                                                   }

{  - OnClose (optional)                                       }
{ If you don't define your event handler, application will be }
{ closed                                                      }
{*************************************************************}
{                     IMPORTANT NOTE:                         }
{ This software is provided 'as-is', without any express or   }
{ implied warranty. In no event will the author be held       }
{ liable for any damages arising from the use of this         }
{ software. I put it in public domain with pleasure.          }
{ Feel free to modify and enhance it as you like.             }
{*************************************************************}
{ INSTALLATION                                                }
{                                                             }
{ Before using this components you need to install it.        }
{ To install, copy the enclosed files into a common VCL       }
{ directory. In Delphi use the Install Component option       }
{ on the Components menu to install it into your component    }
{ library.                                                    }
{                                                             }
{ To use this component, drop it onto a form at design time.  }
{ Set properties to suit your needs and optionaly, define     }
{ OnClose and OnMinimize events.                              }
{                                                             }
{ For more information see DeactMinCloseHelp.html.            }
{*************************************************************}
{ CREDITS:                                                    }
{                                                             }
{   Torry Delphi Page  for all components and sources         }
{   http://www.torry.ru                                       }
{                                                             }
{   David A. Price for "Component create v 4.0"               }
{   http://www.compcreate.com                                 }
{I learn how to make components using this great freeware tool}
{                                                             }
{*************************************************************}
{                                                             }
{ "Pleasure is to give, not to get!"                          }
{                                                             }
{ Tomislav Milic, B.Sc.                                       }
{ milict@yahoo.com                                            }
{ Belgrade                                                    }
{ Yugoslavia                                                  }
{*************************************************************}
{ ****************************************************************** }
{                                                                    }
{   VCL component TDeactMinClose                                     }
{                                                                    }
{   Code generated by Component Create for Delphi                    }
{                                                                    }
{   Generated from source file h:\delphi projects\mydelphicomp\deactminclose.cd }
{   on 7 Oct 1999 at 22:13                                           }
{                                                                    }
{   Copyright  1999 by Milic Tomislav                               }
{                                                                    }
{ ****************************************************************** }

unit DeactMinClose;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics, Extctrls;

type
  TDeactMinClose = class(TComponent)
    private
      { Private fields of TDeactMinClose }
        FDeactivateToMinimize : Longint;
        FIdleToMinimize : Longint;
        FMinimizeToClose : Longint;
        { Pointer to application's OnClose handler, if any }
        FOnClose : TNotifyEvent;
        { Pointer to application's OnMinimize handler, if any }
        FOnMinimize : TNotifyEvent;
        ApplicationsOnActivate : TNotifyEvent;
        ApplicationsOnDeactivate : TNotifyEvent;
        ApplicationsOnIdle : TIdleEvent;
        ApplicationsOnMinimize : TNotifyEvent;
        ApplicationsOnRestore : TNotifyEvent;
        FormsOnKeyDown : TKeyEvent;
        FormsOnMouseMove : TMouseMoveEvent;
        TimerDeactivateToMinimize : TTimer;
        TimerIdleToMinimize : TTimer;
        TimerMinimizeToClose : TTimer;

      { Private methods of TDeactMinClose }
        { Method to set variable and property values and create objects }
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;
        procedure AppClose(Sender: TObject);
        procedure AppMinimize(Sender: TObject);
        procedure DoOnActivate(Sender: TObject);
        procedure DoOnDeactivate(Sender: TObject);
        procedure DoOnIdle(Sender: TObject;var Done:boolean);
        procedure DoOnMinimize(Sender: TObject);
        procedure DoOnRestore(Sender: TObject);
        procedure FormKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
        procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,  Y: Integer);

    protected
      { Protected fields of TDeactMinClose }

      { Protected methods of TDeactMinClose }
        { Method to generate OnClose event }
        procedure Close(Sender : TObject); virtual;
        { Method to generate OnMinimize event }
        procedure Minimize(Sender : TObject); virtual;
        procedure Loaded; override;

    public
      { Public fields and properties of TDeactMinClose }

      { Public methods of TDeactMinClose }
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;

    published
      { Published properties of TDeactMinClose }
        property OnClose : TNotifyEvent read FOnClose write FOnClose;
        property OnMinimize : TNotifyEvent read FOnMinimize write FOnMinimize;
        property DeactivateToMinimize : Longint
             read FDeactivateToMinimize write FDeactivateToMinimize
             default 0;
        property IdleToMinimize : Longint
             read FIdleToMinimize write FIdleToMinimize
             default 0;
        property MinimizeToClose : Longint
             read FMinimizeToClose write FMinimizeToClose
             default 0;

  end;

procedure Register;

implementation

procedure Register;
begin
     { Register TDeactMinClose with Toma as its
       default page on the Delphi component palette }
     RegisterComponents('Toma', [TDeactMinClose]);
end;

{ Method to set variable and property values and create objects }
procedure TDeactMinClose.AutoInitialize;
begin
     ApplicationsOnActivate := nil;
     ApplicationsOnDeactivate := nil;
     ApplicationsOnIdle := nil;
     ApplicationsOnMinimize := nil;
     ApplicationsOnRestore := nil;
     FormsOnKeyDown := nil;
     FormsOnMouseMove := nil;
     TimerDeactivateToMinimize := TTimer.Create(Self);
     TimerIdleToMinimize := TTimer.Create(Self);
     TimerMinimizeToClose := TTimer.Create(Self);
     FDeactivateToMinimize := 0;
     FIdleToMinimize := 0;
     FMinimizeToClose := 0;
end; { of AutoInitialize }

{ Method to free any objects created by AutoInitialize }
procedure TDeactMinClose.AutoDestroy;
begin
     TimerDeactivateToMinimize.Free;
     TimerIdleToMinimize.Free;
     TimerMinimizeToClose.Free;
end; { of AutoDestroy }

{ Method to generate OnClose event }
procedure TDeactMinClose.Close(Sender : TObject);
begin
     { Has the application assigned a method to the event, whether
       via the Object Inspector or a run-time assignment?  If so,
       execute that method }
     if Assigned(FOnClose) then
        FOnClose(Sender);
end;

{ Method to generate OnMinimize event }
procedure TDeactMinClose.Minimize(Sender : TObject);
begin
     { Has the application assigned a method to the event, whether
       via the Object Inspector or a run-time assignment?  If so,
       execute that method }
     if Assigned(FOnMinimize) then
        FOnMinimize(Sender);
end;

procedure TDeactMinClose.AppClose(Sender: TObject);
begin
TimerMinimizeToClose.Enabled := false;
if Assigned(FOnClose)
then FOnClose(Sender)
else Application.Terminate;
end;

procedure TDeactMinClose.AppMinimize(Sender: TObject);
begin
TimerIdleToMinimize.Enabled := false;
TimerDeactivateToMinimize.Enabled := false;
if Assigned(FOnMinimize)
then FOnMinimize(Sender)
else Application.Minimize;
end;

constructor TDeactMinClose.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     AutoInitialize;

     { Code to perform other tasks when the component is created }
end;

destructor TDeactMinClose.Destroy;
begin
     AutoDestroy;
     inherited Destroy;
end;

procedure TDeactMinClose.DoOnActivate(Sender: TObject);
begin
If (csDesigning in ComponentState) then exit;
if Assigned(ApplicationsOnActivate) then ApplicationsOnActivate(Sender);
TimerDeactivateToMinimize.Enabled := false;
end;

procedure TDeactMinClose.DoOnDeactivate(Sender: TObject);
begin
If (csDesigning in ComponentState) then exit;
if Assigned(ApplicationsOnDeactivate) then ApplicationsOnDeactivate(Sender);
if DeactivateToMinimize > 0 then
TimerDeactivateToMinimize.Enabled := true;
end;

procedure TDeactMinClose.DoOnIdle(Sender: TObject;var Done:boolean);
begin
TimerIdleToMinimize.Enabled := true;
if Assigned(ApplicationsOnIdle) then ApplicationsOnIdle(Sender,Done);

{Don't call this code again while in idle state:}
Application.OnIdle := ApplicationsOnIdle;
end;

procedure TDeactMinClose.DoOnMinimize(Sender: TObject);
begin
If (csDesigning in ComponentState) then exit;
if Assigned(ApplicationsOnMinimize) then ApplicationsOnMinimize(Sender);
if MinimizeToClose > 0 then
TimerMinimizeToClose.Enabled := true;
end;

procedure TDeactMinClose.DoOnRestore(Sender: TObject);
begin
If (csDesigning in ComponentState) then exit;
TimerMinimizeToClose.Enabled := false;
if Assigned(ApplicationsOnRestore) then ApplicationsOnRestore(Sender);
end;

procedure TDeactMinClose.FormKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
begin
TimerIdleToMinimize.Enabled := false;
Application.OnIdle := DoOnIdle;

if Assigned(FormsOnKeyDown)
then FormsOnKeyDown(Sender, Key, Shift);
end;

procedure TDeactMinClose.FormMouseMove(Sender: TObject; Shift: TShiftState; X,  Y: Integer);
begin
TimerIdleToMinimize.Enabled := false;
Application.OnIdle := DoOnIdle;

if Assigned(FormsOnMouseMove) then
FormsOnMouseMove(Sender, Shift, X,  Y);
end;

procedure TDeactMinClose.Loaded;
begin
     inherited Loaded;

     { Perform any component setup that depends on the property
       values having been set }
If (csDesigning in ComponentState) then exit;

{If Application has assigned methods
OnMinimize, OnRestore, OnDeactivate, OnActivate,  OnIdle
save them for later use}

if Assigned(Application.OnMinimize) then
ApplicationsOnMinimize := Application.OnMinimize;
Application.OnMinimize := DoOnMinimize;

if Assigned(Application.OnRestore) then
ApplicationsOnRestore := Application.OnRestore;
Application.OnRestore := DoOnRestore;

if Assigned(Application.OnDeactivate) then
ApplicationsOnDeactivate := Application.OnDeactivate;
Application.OnDeactivate := DoOnDeactivate;

if Assigned(Application.OnActivate) then
ApplicationsOnActivate := Application.OnActivate;
Application.OnActivate := DoOnActivate;

if Assigned(Application.OnIdle) then
ApplicationsOnIdle := Application.OnIdle;
Application.OnIdle := DoOnIdle;

{Forms KeyPreview must be set if we want to be notified of any Keypress.
See online help for keys not generateing KeyPress events!}

(Owner as TForm).KeyPreview := true;

{If Form has assigned methods
OnKeyDown or OnMouseMove
save them for later use}

if Assigned((Owner as TForm).OnKeyDown) then
FormsOnKeyDown := (Owner as TForm).OnKeyDown;
(Owner as TForm).OnKeyDown := FormKeyDown;

if Assigned((Owner as TForm).OnMouseMove) then
FormsOnMouseMove := (Owner as TForm).OnMouseMove;
(Owner as TForm).OnMouseMove := FormMouseMove;

     TimerMinimizeToClose.Enabled := false;
     TimerMinimizeToClose.Interval := 60*1000*FMinimizeToClose;
     TimerMinimizeToClose.OnTimer := AppClose;

     TimerDeactivateToMinimize.Enabled := false;
     TimerDeactivateToMinimize.Interval := 60*1000*FDeactivateToMinimize;
     TimerDeactivateToMinimize.OnTimer := AppMinimize;

     TimerIdleToMinimize.Enabled := false;
     TimerIdleToMinimize.Interval := 60*1000*FIdleToMinimize;
     TimerIdleToMinimize.OnTimer := AppMinimize;

end;


end.
